/// The Juggler animation framework to animate values and display objects.
///
/// Please read the wiki article about the Juggler animation framework here:
/// [The Juggler](http://www.stagexl.org/docs/wiki-articles.html?article=juggler)
///
/// Built in transition function (easing functions) can be viewed here:
/// [Transition Functions](http://www.stagexl.org/docs/transitions.html)
///
library stagexl.animation;

import 'dart:async';
import 'dart:math';

part 'animation/animatable.dart';
part 'animation/animation_chain.dart';
part 'animation/animation_group.dart';
part 'animation/delayed_call.dart';
part 'animation/juggler.dart';
part 'animation/transition.dart';
part 'animation/translation.dart';
part 'animation/tween.dart';
part 'animation/tween_object.dart';
part 'animation/tween_property.dart';
part 'animation/tween_property_accessor.dart';
